import { UkePureComponent } from '../utils/uke-component';
export interface DateBasicProps {
    onChange?: (nextValue: any) => void;
    /** 是否需要时分秒 */
    needTime?: boolean;
    /** 是否转换成标准 UTC 时间 */
    toUTC?: boolean;
    /** 默认的时分秒的值 */
    defaultTimes?: string[];
    /** 是否输出字符串格式，默认为原生 Date 对象 */
    outputAsString?: boolean;
}
export declare class DateBasic<P extends DateBasicProps, S = {}, SS = {}> extends UkePureComponent<P, S, SS> {
    dateFormat: string;
    timeFormat: string;
    emitChangeValue: (val: any) => string | string[];
}
