import { UkeComponent } from '../utils/uke-component';
import { getScreenWidth } from '../utils/screen';
export interface DragPanelClassProps {
    topLimit?: number;
}
export declare class DragPanelClass<P extends DragPanelClassProps> extends UkeComponent<P> {
    drapElemInfo: {
        isDrapStart: boolean;
        dragElem: HTMLElement | undefined;
        dragOriginX: number;
        dragOriginY: number;
        elemOrigonX: number;
        elemOriginY: number;
    };
    getScreenWidth: typeof getScreenWidth;
    isSetPosition: any;
    setLayoutInitPosition: (elem: HTMLElement) => void;
    dragStart(event: any, elem: any): void;
    mouseMoving(): void;
    mouseMoved(): void;
    setContainerPosition: (event: any) => void;
    dragEnd: (event: any) => void;
}
