/// <reference types="react" />
import MapperFilter, { Column } from './mapper-filter';
export interface DescColumn extends Column {
    /** 是否独占一行 */
    block?: boolean;
}
export declare type DescHelperKeyMapper = DescColumn;
export interface DescHelperProps {
    /** 需要改名为 columns */
    keyMapper?: DescHelperKeyMapper[];
    /** 表格的 columns */
    columns: DescColumn[];
    /** records 中的项 */
    record: {
        [key: string]: any;
    };
    /** 是否使用竖列显示 */
    col?: boolean;
    /** className */
    className?: string;
}
/**
 * 具体单独数据的渲染模版
 *
 * @export
 * @class DescHelper
 * @extends {MapperFilter}
 */
export default class DescHelper extends MapperFilter<DescHelperProps> {
    render(): JSX.Element;
}
