import React from 'react';
interface StepsProps {
    /** 当前激活的位置 */
    activeIdx: number;
    /** 传入 steps-container 的 class */
    className: string;
    /** children，可以为任意元素，但是最好为 Step */
    children: JSX.Element | JSX.Element[];
    /** 所有 Step 的对齐方式，参考 layout 说明 */
    justify: 'center' | 'start' | 'end' | 'between' | 'around';
}
export default class Steps extends React.PureComponent<StepsProps> {
    static Step: React.FunctionComponent<import("./step").StepProps>;
    static defaultProps: {
        activeIdx: number;
        justify: string;
        className: string;
    };
    render(): JSX.Element;
}
export {};
