import { PureComponent } from 'react';
export interface QRCodeProps {
    /** 需要生成 QRCode 的字符串 */
    origin: string;
}
declare type APIQueryQRCode = (getData: (base64Res: string) => void, origin: string) => void;
export declare class QRCode extends PureComponent<QRCodeProps, {
    qrbase64: string;
}> {
    static setAPI: (api: APIQueryQRCode) => void;
    constructor(props: any);
    /**
     * 接口说明
     * 引用时需要定义对于的接口，详情请参考对于的调用方法
     */
    queryData(): void;
    componentDidMount(): void;
    getCacha: () => void;
    render(): JSX.Element;
}
export {};
