import React from 'react';
import { IconProps } from '../icon/icon';
export interface MenuProps {
    /** 内容 */
    text?: any;
    /** ID */
    id?: string | number;
    /** Icon */
    icon?: string;
    /** 参考 PureIcon */
    pureIcon?: string;
    /** 参考 PureIcon */
    s?: IconProps['s'];
    /** isActive */
    isActive?: boolean;
    /** 点击 Menu 的回调 */
    onClick?: (event?: React.MouseEvent<HTMLDivElement, MouseEvent>) => void;
}
declare const Menu: React.SFC<MenuProps>;
export default Menu;
