var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React from 'react';
import { $T } from '../config';
import { Icon, PureIcon } from '../icon';
var Menu = function (props) {
    var isActive = props.isActive, text = props.text, icon = props.icon, s = props.s, pureIcon = props.pureIcon, children = props.children, id = props.id, other = __rest(props, ["isActive", "text", "icon", "s", "pureIcon", "children", "id"]);
    var I = pureIcon ? React.createElement(PureIcon, { n: pureIcon }) : icon && React.createElement(Icon, { n: icon, s: s });
    return (React.createElement("div", __assign({ className: "menu-item" + (isActive ? ' active' : '') }, other),
        I,
        $T(text),
        children));
};
export default Menu;
