import { PureComponent } from 'react';
export interface MultipleProps {
    /** onChange */
    onChange: (val: any) => void;
    /** 是否可输入 */
    inputable?: boolean;
    /** 每一次输入的单位 */
    basicUnit?: number;
    /** 最小输入 */
    min?: number;
    /** 最大输入 */
    max?: number;
    /** 默认值 */
    defaultValue?: any;
    /** 后缀 */
    suffix?: string;
    /** 下拉提示的组合 */
    range?: number[];
}
interface State {
    isShowIdea: boolean;
    value: any;
}
export default class Multiple extends PureComponent<MultipleProps, State> {
    static defaultProps: {
        max: number;
        inputable: boolean;
        min: number;
        range: number[];
    };
    multipleHelper: any;
    constructor(props: any);
    componentDidMount(): void;
    multipleOperation(symbol: any): void;
    changeValue(val: any): void;
    checkValue(): void;
    setIdea(isShow: any): void;
    render(): JSX.Element;
}
export {};
