import { Component } from 'react';
export interface PopoverHelperState {
    relativeElem: HTMLElement;
    open: boolean;
    children: any;
}
export declare class PopoverWrapper extends Component<{}, PopoverHelperState> {
    constructor(props: any);
    closePopover(): void;
    close(): void;
    show(elem: HTMLElement, isShow: boolean, children: any, props: {}): void;
    render(): JSX.Element;
}
export interface PopoverConstructorOptions {
    /** 是否设置 css position: fixed */
    fixed?: boolean;
    /** id */
    id?: string;
}
export interface PopShowParams {
    elem?: HTMLElement | EventTarget;
    children?: any;
    open?: boolean;
    props?: {};
}
interface PopSetParams extends PopShowParams {
    open: boolean;
}
export declare class PopoverEntity {
    id: any;
    idPrefix: string;
    prevProps: any;
    lifeTimer: any;
    popoverEntity: any;
    prevOptions: {};
    constructor(options?: PopoverConstructorOptions);
    savePopWrapper: (e: PopoverWrapper) => void;
    initDOM(props: any): void;
    show(options: PopShowParams): void;
    set(options: PopSetParams): void;
    close(): void;
    destroy: () => void;
    delayClose(timer?: number): void;
}
export {};
