/// <reference types="react" />
/**
 * 帮助组件修改名字的辅助函数
 *
 * @param {component} NewComponent 新的 component
 * @param {string} oldComponentName 旧的 component 的显示名字
 * @param {string} newComponentName 新的 component 的显示名字
 */
declare const Rename: (NewComponent: any, oldComponentName: string, newComponentName: string) => (props: any) => JSX.Element;
export default Rename;
