import React from 'react';
import Icon from '../icon/icon';
var typeMapper = {
    success: 'check',
    normal: '',
    wran: 'exclamation',
    error: 'times',
};
var Step = function (_a) {
    var title = _a.title, children = _a.children, isActive = _a.isActive, isChecked = _a.isChecked, _b = _a.type, type = _b === void 0 ? 'success' : _b, _c = _a.idx, idx = _c === void 0 ? '' : _c, style = _a.style;
    return (React.createElement("span", { className: "step-item " + type + " " + (isActive ? 'active' : '') + " " + (isChecked ? 'checked' : ''), style: style },
        React.createElement("span", { className: "tip-item" },
            React.createElement("span", { className: "tip-idx" }, !isChecked ? +idx + 1 : (React.createElement(Icon, { n: typeMapper[type] || type }))),
            React.createElement("span", { className: "title" }, title)),
        React.createElement("div", { className: "desc" }, children)));
};
export default Step;
