import React from 'react';
var Tip = function (_a) {
    var _b = _a.scale, scale = _b === void 0 ? 10 : _b, _c = _a.color, color = _c === void 0 ? 'theme' : _c, children = _a.children, _d = _a.animate, animate = _d === void 0 ? true : _d;
    var tipStyle = {
        height: scale,
        lineHeight: scale - 1 + "px",
        width: scale
    };
    return (React.createElement("div", { className: "__tip-item", style: tipStyle },
        React.createElement("span", { className: "tip " + color }),
        animate && (React.createElement("span", { className: "tip animate " + color })),
        React.createElement("span", { className: "c" }, children)));
};
export default Tip;
