/// <reference types="react" />
import { ButtonProps } from "../button/button-basic";
export declare type NatureColorTypes = 'theme' | 'white' | 'red' | 'orange' | 'yellow' | 'blue' | 'green' | 'purple';
export declare type GrayColorTypes = 'white' | 'black' | 'grey';
export declare type StatusColorTypes = 'primary' | 'default' | 'important' | 'danger' | 'success' | 'error' | 'warn';
export declare type Color = NatureColorTypes | GrayColorTypes | StatusColorTypes;
export declare type Sizes = 'xl' | 'lg' | 'md' | 'sm' | 'tiny';
export interface BtnItemConfig extends ButtonProps {
    /** 该按钮的操作 */
    action?: () => void;
    /** className */
    className?: string;
}
export declare type Children = JSX.Element | JSX.Element[] | boolean | string | null | undefined;
export declare type FuncChildren = () => Children;
export declare type DivideType = '-' | 'hr';
