/// <reference types="node" />
import { Component } from 'react';
interface CountdownProps {
    start: number;
    freq: number;
    onTimeout: () => void;
    needBg?: boolean;
    needProgress?: boolean;
    jumpClass?: string;
    firstStopColor?: string;
    secondStopColor?: string;
    countdownNotifyTimer?: any;
    onCountdownNotify?: () => void;
}
export default class Countdown extends Component<CountdownProps, {
    isTimerStart: boolean;
    countdown: number;
}> {
    static defaultProps: {
        firstStopColor: string;
        secondStopColor: string;
    };
    interval: any;
    jumpElem: any;
    constructor(props: any);
    startCountdown(): void;
    setJumpElemCount(timeObj: any): void;
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    componentDidMount(): void;
    componentDidUpdate(): void;
    _clearTimer(): void;
    clearTimer(): void;
    componentWillUnmount(): void;
    startTimer(): NodeJS.Timeout;
    getBgDOM(timeObj: any, time: any, idx: any): JSX.Element | "";
    render(): JSX.Element;
}
export {};
