import React, { Component } from 'react';
interface CountdownProps {
    /** 时间到 0 的时候触发的回调 */
    onTimeout: () => void;
    /** 倒计时开始时间 */
    start: number;
    /** 每一个 flip 的宽度 */
    width?: number;
    /** 每一个 flip 的高度 */
    height?: number;
    className: string;
    /** 给每一个 flip 的 style */
    flipItemstyle?: React.CSSProperties;
    /** 需要广播的时间节点 */
    countdownNotifyTimer?: number;
    /** 广播的时间节点触发的回调 */
    onCountdownNotify?: () => void;
}
export default class Countdown extends Component<CountdownProps, {
    isTimerStart: boolean;
    countdown: number;
}> {
    static defaultProps: {
        width: number;
        height: number;
    };
    jumpElem: any;
    interval: any;
    constructor(props: any);
    shouldComponentUpdate(nextProps: any, nextState: any): boolean;
    componentDidMount(): void;
    componentDidUpdate(prevProps: any, prevState: any): void;
    componentWillUnmount(): void;
    startCountdown(): void;
    setJumpElemCount(timeObj: any): void;
    clearTimer(): void;
    startTimer(): void;
    render(): JSX.Element;
}
export {};
